// Compiled by ClojureScript 0.0-2138
goog.provide('lt.object');
goog.require('cljs.core');
goog.require('lt.util.dom');
goog.require('lt.util.js');
goog.require('crate.binding');
goog.require('lt.util.js');
goog.require('lt.util.dom');
goog.require('lt.util.cljs');
goog.require('crate.core');
goog.require('lt.util.dom');
goog.require('clojure.string');
goog.require('lt.util.cljs');
goog.require('clojure.set');
goog.require('clojure.string');
goog.require('crate.binding');
goog.require('clojure.set');
goog.require('crate.core');
/**
* Counter to guarantee unique object ids
*/
lt.object.obj_id = cljs.core.atom.call(null,0);
/**
* Map of object ids to objects created by object/create
*/
lt.object.instances = cljs.core.atom.call(null,cljs.core.sorted_map.call(null));
/**
* Map of behavior names to behaviors created by macros/behavior
*/
lt.object.behaviors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of object template keys to template maps created by object/object*
*/
lt.object.object_defs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to associated lists of behaviors
*/
lt.object.tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to dissociated lists of behaviors e.g. :-behavior
*/
lt.object.negated_tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Metadata of current behavior set during raise and raise-reduce
*/
lt.object._STAR_behavior_meta_STAR_ = null;
lt.object.add = (function add(obj){return cljs.core.swap_BANG_.call(null,lt.object.object_defs,cljs.core.assoc,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(obj),obj);
});
lt.object.add_behavior = (function add_behavior(beh){return cljs.core.swap_BANG_.call(null,lt.object.behaviors,cljs.core.assoc,new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh),beh);
});
/**
* Return id of given object
*/
lt.object.__GT_id = (function __GT_id(obj){if(crate.binding.deref_QMARK_.call(null,obj))
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
} else
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);
}
});
lt.object.__GT_behavior_name = (function __GT_behavior_name(beh){if(cljs.core.coll_QMARK_.call(null,beh))
{return cljs.core.first.call(null,beh);
} else
{return beh;
}
});
lt.object.__GT_behavior = (function __GT_behavior(beh){return cljs.core.deref.call(null,lt.object.behaviors).call(null,lt.object.__GT_behavior_name.call(null,beh));
});
lt.object.__GT_triggers = (function __GT_triggers(behs){var result = cljs.core.atom.call(null,cljs.core.transient$.call(null,cljs.core.PersistentArrayMap.EMPTY));var seq__5155_5167 = cljs.core.seq.call(null,behs);var chunk__5160_5168 = null;var count__5161_5169 = 0;var i__5162_5170 = 0;while(true){
if((i__5162_5170 < count__5161_5169))
{var beh_5171 = cljs.core._nth.call(null,chunk__5160_5168,i__5162_5170);var seq__5163_5172 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_5171)));var chunk__5164_5173 = null;var count__5165_5174 = 0;var i__5166_5175 = 0;while(true){
if((i__5166_5175 < count__5165_5174))
{var t_5176 = cljs.core._nth.call(null,chunk__5164_5173,i__5166_5175);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_5176,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_5176);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_5171));
{
var G__5177 = seq__5163_5172;
var G__5178 = chunk__5164_5173;
var G__5179 = count__5165_5174;
var G__5180 = (i__5166_5175 + 1);
seq__5163_5172 = G__5177;
chunk__5164_5173 = G__5178;
count__5165_5174 = G__5179;
i__5166_5175 = G__5180;
continue;
}
} else
{var temp__4092__auto___5181 = cljs.core.seq.call(null,seq__5163_5172);if(temp__4092__auto___5181)
{var seq__5163_5182__$1 = temp__4092__auto___5181;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5163_5182__$1))
{var c__4262__auto___5183 = cljs.core.chunk_first.call(null,seq__5163_5182__$1);{
var G__5184 = cljs.core.chunk_rest.call(null,seq__5163_5182__$1);
var G__5185 = c__4262__auto___5183;
var G__5186 = cljs.core.count.call(null,c__4262__auto___5183);
var G__5187 = 0;
seq__5163_5172 = G__5184;
chunk__5164_5173 = G__5185;
count__5165_5174 = G__5186;
i__5166_5175 = G__5187;
continue;
}
} else
{var t_5188 = cljs.core.first.call(null,seq__5163_5182__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_5188,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_5188);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_5171));
{
var G__5189 = cljs.core.next.call(null,seq__5163_5182__$1);
var G__5190 = null;
var G__5191 = 0;
var G__5192 = 0;
seq__5163_5172 = G__5189;
chunk__5164_5173 = G__5190;
count__5165_5174 = G__5191;
i__5166_5175 = G__5192;
continue;
}
}
} else
{}
}
break;
}
{
var G__5193 = seq__5155_5167;
var G__5194 = chunk__5160_5168;
var G__5195 = count__5161_5169;
var G__5196 = (i__5162_5170 + 1);
seq__5155_5167 = G__5193;
chunk__5160_5168 = G__5194;
count__5161_5169 = G__5195;
i__5162_5170 = G__5196;
continue;
}
} else
{var temp__4092__auto___5197 = cljs.core.seq.call(null,seq__5155_5167);if(temp__4092__auto___5197)
{var seq__5155_5198__$1 = temp__4092__auto___5197;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5155_5198__$1))
{var c__4262__auto___5199 = cljs.core.chunk_first.call(null,seq__5155_5198__$1);{
var G__5200 = cljs.core.chunk_rest.call(null,seq__5155_5198__$1);
var G__5201 = c__4262__auto___5199;
var G__5202 = cljs.core.count.call(null,c__4262__auto___5199);
var G__5203 = 0;
seq__5155_5167 = G__5200;
chunk__5160_5168 = G__5201;
count__5161_5169 = G__5202;
i__5162_5170 = G__5203;
continue;
}
} else
{var beh_5204 = cljs.core.first.call(null,seq__5155_5198__$1);var seq__5156_5205 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_5204)));var chunk__5157_5206 = null;var count__5158_5207 = 0;var i__5159_5208 = 0;while(true){
if((i__5159_5208 < count__5158_5207))
{var t_5209 = cljs.core._nth.call(null,chunk__5157_5206,i__5159_5208);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_5209,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_5209);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_5204));
{
var G__5210 = seq__5156_5205;
var G__5211 = chunk__5157_5206;
var G__5212 = count__5158_5207;
var G__5213 = (i__5159_5208 + 1);
seq__5156_5205 = G__5210;
chunk__5157_5206 = G__5211;
count__5158_5207 = G__5212;
i__5159_5208 = G__5213;
continue;
}
} else
{var temp__4092__auto___5214__$1 = cljs.core.seq.call(null,seq__5156_5205);if(temp__4092__auto___5214__$1)
{var seq__5156_5215__$1 = temp__4092__auto___5214__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5156_5215__$1))
{var c__4262__auto___5216 = cljs.core.chunk_first.call(null,seq__5156_5215__$1);{
var G__5217 = cljs.core.chunk_rest.call(null,seq__5156_5215__$1);
var G__5218 = c__4262__auto___5216;
var G__5219 = cljs.core.count.call(null,c__4262__auto___5216);
var G__5220 = 0;
seq__5156_5205 = G__5217;
chunk__5157_5206 = G__5218;
count__5158_5207 = G__5219;
i__5159_5208 = G__5220;
continue;
}
} else
{var t_5221 = cljs.core.first.call(null,seq__5156_5215__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_5221,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_5221);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_5204));
{
var G__5222 = cljs.core.next.call(null,seq__5156_5215__$1);
var G__5223 = null;
var G__5224 = 0;
var G__5225 = 0;
seq__5156_5205 = G__5222;
chunk__5157_5206 = G__5223;
count__5158_5207 = G__5224;
i__5159_5208 = G__5225;
continue;
}
}
} else
{}
}
break;
}
{
var G__5226 = cljs.core.next.call(null,seq__5155_5198__$1);
var G__5227 = null;
var G__5228 = 0;
var G__5229 = 0;
seq__5155_5167 = G__5226;
chunk__5160_5168 = G__5227;
count__5161_5169 = G__5228;
i__5162_5170 = G__5229;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.persistent_BANG_.call(null,cljs.core.deref.call(null,result));
});
lt.object.specificity_sort = (function() {
var specificity_sort = null;
var specificity_sort__1 = (function (xs){return specificity_sort.call(null,xs,null);
});
var specificity_sort__2 = (function (xs,dir){var arr = [];var seq__5234_5238 = cljs.core.seq.call(null,xs);var chunk__5235_5239 = null;var count__5236_5240 = 0;var i__5237_5241 = 0;while(true){
if((i__5237_5241 < count__5236_5240))
{var x_5242 = cljs.core._nth.call(null,chunk__5235_5239,i__5237_5241);arr.push([[cljs.core.str(x_5242)].join('').split(".").length,[cljs.core.str(x_5242)].join(''),x_5242]);
{
var G__5243 = seq__5234_5238;
var G__5244 = chunk__5235_5239;
var G__5245 = count__5236_5240;
var G__5246 = (i__5237_5241 + 1);
seq__5234_5238 = G__5243;
chunk__5235_5239 = G__5244;
count__5236_5240 = G__5245;
i__5237_5241 = G__5246;
continue;
}
} else
{var temp__4092__auto___5247 = cljs.core.seq.call(null,seq__5234_5238);if(temp__4092__auto___5247)
{var seq__5234_5248__$1 = temp__4092__auto___5247;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5234_5248__$1))
{var c__4262__auto___5249 = cljs.core.chunk_first.call(null,seq__5234_5248__$1);{
var G__5250 = cljs.core.chunk_rest.call(null,seq__5234_5248__$1);
var G__5251 = c__4262__auto___5249;
var G__5252 = cljs.core.count.call(null,c__4262__auto___5249);
var G__5253 = 0;
seq__5234_5238 = G__5250;
chunk__5235_5239 = G__5251;
count__5236_5240 = G__5252;
i__5237_5241 = G__5253;
continue;
}
} else
{var x_5254 = cljs.core.first.call(null,seq__5234_5248__$1);arr.push([[cljs.core.str(x_5254)].join('').split(".").length,[cljs.core.str(x_5254)].join(''),x_5254]);
{
var G__5255 = cljs.core.next.call(null,seq__5234_5248__$1);
var G__5256 = null;
var G__5257 = 0;
var G__5258 = 0;
seq__5234_5238 = G__5255;
chunk__5235_5239 = G__5256;
count__5236_5240 = G__5257;
i__5237_5241 = G__5258;
continue;
}
}
} else
{}
}
break;
}
arr.sort();
if(cljs.core.truth_(dir))
{} else
{arr.reverse();
}
var arr__3409__auto___5259 = arr;var i_5260 = 0;while(true){
if((i_5260 < arr__3409__auto___5259.length))
{(arr[i_5260] = (arr[i_5260][2]));
{
var G__5261 = (i_5260 + 1);
i_5260 = G__5261;
continue;
}
} else
{}
break;
}
return arr;
});
specificity_sort = function(xs,dir){
switch(arguments.length){
case 1:
return specificity_sort__1.call(this,xs);
case 2:
return specificity_sort__2.call(this,xs,dir);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
specificity_sort.cljs$core$IFn$_invoke$arity$1 = specificity_sort__1;
specificity_sort.cljs$core$IFn$_invoke$arity$2 = specificity_sort__2;
return specificity_sort;
})()
;
lt.object.ts__GT_negations = (function ts__GT_negations(ts){var seen = (function (){var obj5269 = {};return obj5269;
})();var seq__5270_5274 = cljs.core.seq.call(null,cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.negated_tags),ts)));var chunk__5271_5275 = null;var count__5272_5276 = 0;var i__5273_5277 = 0;while(true){
if((i__5273_5277 < count__5272_5276))
{var beh_5278 = cljs.core._nth.call(null,chunk__5271_5275,i__5273_5277);(seen[lt.object.__GT_behavior_name.call(null,beh_5278)] = true);
{
var G__5279 = seq__5270_5274;
var G__5280 = chunk__5271_5275;
var G__5281 = count__5272_5276;
var G__5282 = (i__5273_5277 + 1);
seq__5270_5274 = G__5279;
chunk__5271_5275 = G__5280;
count__5272_5276 = G__5281;
i__5273_5277 = G__5282;
continue;
}
} else
{var temp__4092__auto___5283 = cljs.core.seq.call(null,seq__5270_5274);if(temp__4092__auto___5283)
{var seq__5270_5284__$1 = temp__4092__auto___5283;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5270_5284__$1))
{var c__4262__auto___5285 = cljs.core.chunk_first.call(null,seq__5270_5284__$1);{
var G__5286 = cljs.core.chunk_rest.call(null,seq__5270_5284__$1);
var G__5287 = c__4262__auto___5285;
var G__5288 = cljs.core.count.call(null,c__4262__auto___5285);
var G__5289 = 0;
seq__5270_5274 = G__5286;
chunk__5271_5275 = G__5287;
count__5272_5276 = G__5288;
i__5273_5277 = G__5289;
continue;
}
} else
{var beh_5290 = cljs.core.first.call(null,seq__5270_5284__$1);(seen[lt.object.__GT_behavior_name.call(null,beh_5290)] = true);
{
var G__5291 = cljs.core.next.call(null,seq__5270_5284__$1);
var G__5292 = null;
var G__5293 = 0;
var G__5294 = 0;
seq__5270_5274 = G__5291;
chunk__5271_5275 = G__5292;
count__5272_5276 = G__5293;
i__5273_5277 = G__5294;
continue;
}
}
} else
{}
}
break;
}
return seen;
});
lt.object.tags__GT_behaviors = (function tags__GT_behaviors(ts){var duped = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),lt.object.specificity_sort.call(null,ts)));var de_duped = cljs.core.reduce.call(null,((function (duped){
return (function (res,cur){if(cljs.core.truth_((new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)])))
{return res;
} else
{var beh = lt.object.__GT_behavior.call(null,cur);if(cljs.core.truth_(new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{if(cljs.core.coll_QMARK_.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{var seq__5299_5303 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh));var chunk__5300_5304 = null;var count__5301_5305 = 0;var i__5302_5306 = 0;while(true){
if((i__5302_5306 < count__5301_5305))
{var exclude_5307 = cljs.core._nth.call(null,chunk__5300_5304,i__5302_5306);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_5307] = true);
{
var G__5308 = seq__5299_5303;
var G__5309 = chunk__5300_5304;
var G__5310 = count__5301_5305;
var G__5311 = (i__5302_5306 + 1);
seq__5299_5303 = G__5308;
chunk__5300_5304 = G__5309;
count__5301_5305 = G__5310;
i__5302_5306 = G__5311;
continue;
}
} else
{var temp__4092__auto___5312 = cljs.core.seq.call(null,seq__5299_5303);if(temp__4092__auto___5312)
{var seq__5299_5313__$1 = temp__4092__auto___5312;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5299_5313__$1))
{var c__4262__auto___5314 = cljs.core.chunk_first.call(null,seq__5299_5313__$1);{
var G__5315 = cljs.core.chunk_rest.call(null,seq__5299_5313__$1);
var G__5316 = c__4262__auto___5314;
var G__5317 = cljs.core.count.call(null,c__4262__auto___5314);
var G__5318 = 0;
seq__5299_5303 = G__5315;
chunk__5300_5304 = G__5316;
count__5301_5305 = G__5317;
i__5302_5306 = G__5318;
continue;
}
} else
{var exclude_5319 = cljs.core.first.call(null,seq__5299_5313__$1);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_5319] = true);
{
var G__5320 = cljs.core.next.call(null,seq__5299_5313__$1);
var G__5321 = null;
var G__5322 = 0;
var G__5323 = 0;
seq__5299_5303 = G__5320;
chunk__5300_5304 = G__5321;
count__5301_5305 = G__5322;
i__5302_5306 = G__5323;
continue;
}
}
} else
{}
}
break;
}
} else
{}
(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)] = true);
} else
{}
cljs.core.conj_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(res),cur);
return res;
}
});})(duped))
,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"seen","seen",1017430509),lt.object.ts__GT_negations.call(null,ts),new cljs.core.Keyword(null,"final","final",1111340264),cljs.core.transient$.call(null,cljs.core.PersistentVector.EMPTY)], null),duped);return cljs.core.reverse.call(null,cljs.core.persistent_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(de_duped)));
});
lt.object.trigger__GT_behaviors = (function trigger__GT_behaviors(trig,ts){return cljs.core.get.call(null,lt.object.__GT_triggers.call(null,lt.object.tags__GT_behaviors.call(null,ts)),trig);
});
lt.object.safe_report_error = (function safe_report_error(e){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.error(e);
} else
{return console.error(((typeof e === 'string')?e:e.stack));
}
});
lt.object.raise_STAR_ = (function() {
var raise_STAR_ = null;
var raise_STAR___3 = (function (obj,reactions,args){return raise_STAR_.call(null,obj,reactions,args,null);
});
var raise_STAR___4 = (function (obj,reactions,args,trigger){var seq__5338 = cljs.core.seq.call(null,reactions);var chunk__5341 = null;var count__5342 = 0;var i__5343 = 0;while(true){
if((i__5343 < count__5342))
{var r = cljs.core._nth.call(null,chunk__5341,i__5343);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start5347_5352 = (new Date()).getTime();var _STAR_behavior_meta_STAR_5348_5353 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_5348_5353;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start5347_5352),trigger);
}
}catch (e5346){if((e5346 instanceof Error))
{var e_5354 = e5346;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_5354);
} else
{if((e5346 instanceof global.Error))
{var e_5355 = e5346;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_5355);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e5346;
} else
{}
}
}
}{
var G__5356 = seq__5338;
var G__5357 = chunk__5341;
var G__5358 = count__5342;
var G__5359 = (i__5343 + 1);
seq__5338 = G__5356;
chunk__5341 = G__5357;
count__5342 = G__5358;
i__5343 = G__5359;
continue;
}
} else
{{
var G__5360 = seq__5338;
var G__5361 = chunk__5341;
var G__5362 = count__5342;
var G__5363 = (i__5343 + 1);
seq__5338 = G__5360;
chunk__5341 = G__5361;
count__5342 = G__5362;
i__5343 = G__5363;
continue;
}
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__5338);if(temp__4092__auto__)
{var seq__5338__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5338__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__5338__$1);{
var G__5364 = cljs.core.chunk_rest.call(null,seq__5338__$1);
var G__5365 = c__4262__auto__;
var G__5366 = cljs.core.count.call(null,c__4262__auto__);
var G__5367 = 0;
seq__5338 = G__5364;
chunk__5341 = G__5365;
count__5342 = G__5366;
i__5343 = G__5367;
continue;
}
} else
{var r = cljs.core.first.call(null,seq__5338__$1);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start5350_5368 = (new Date()).getTime();var _STAR_behavior_meta_STAR_5351_5369 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_5351_5369;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start5350_5368),trigger);
}
}catch (e5349){if((e5349 instanceof Error))
{var e_5370 = e5349;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_5370);
} else
{if((e5349 instanceof global.Error))
{var e_5371 = e5349;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_5371);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e5349;
} else
{}
}
}
}{
var G__5372 = cljs.core.next.call(null,seq__5338__$1);
var G__5373 = null;
var G__5374 = 0;
var G__5375 = 0;
seq__5338 = G__5372;
chunk__5341 = G__5373;
count__5342 = G__5374;
i__5343 = G__5375;
continue;
}
} else
{{
var G__5376 = cljs.core.next.call(null,seq__5338__$1);
var G__5377 = null;
var G__5378 = 0;
var G__5379 = 0;
seq__5338 = G__5376;
chunk__5341 = G__5377;
count__5342 = G__5378;
i__5343 = G__5379;
continue;
}
}
}
} else
{return null;
}
}
break;
}
});
raise_STAR_ = function(obj,reactions,args,trigger){
switch(arguments.length){
case 3:
return raise_STAR___3.call(this,obj,reactions,args);
case 4:
return raise_STAR___4.call(this,obj,reactions,args,trigger);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
raise_STAR_.cljs$core$IFn$_invoke$arity$3 = raise_STAR___3;
raise_STAR_.cljs$core$IFn$_invoke$arity$4 = raise_STAR___4;
return raise_STAR_;
})()
;
/**
* Invoke object's behavior fns for given trigger. Args are passed to behavior fns
* @param {...*} var_args
*/
lt.object.raise = (function() { 
var raise__delegate = function (obj,k,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return lt.object.raise_STAR_.call(null,obj,reactions,args,k);
};
var raise = function (obj,k,var_args){
var args = null;if (arguments.length > 2) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return raise__delegate.call(this,obj,k,args);};
raise.cljs$lang$maxFixedArity = 2;
raise.cljs$lang$applyTo = (function (arglist__5380){
var obj = cljs.core.first(arglist__5380);
arglist__5380 = cljs.core.next(arglist__5380);
var k = cljs.core.first(arglist__5380);
var args = cljs.core.rest(arglist__5380);
return raise__delegate(obj,k,args);
});
raise.cljs$core$IFn$_invoke$arity$variadic = raise__delegate;
return raise;
})()
;
/**
* For a given behavior keyword id, call its :reaction fn with given args
* @param {...*} var_args
*/
lt.object.call_behavior_reaction = (function() { 
var call_behavior_reaction__delegate = function (id,args){var behavior_fn = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,id));if(cljs.core.truth_(behavior_fn))
{} else
{throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"behavior-fn","behavior-fn",-1300659236,null)))].join('')));
}
return cljs.core.apply.call(null,behavior_fn,args);
};
var call_behavior_reaction = function (id,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return call_behavior_reaction__delegate.call(this,id,args);};
call_behavior_reaction.cljs$lang$maxFixedArity = 1;
call_behavior_reaction.cljs$lang$applyTo = (function (arglist__5381){
var id = cljs.core.first(arglist__5381);
var args = cljs.core.rest(arglist__5381);
return call_behavior_reaction__delegate(id,args);
});
call_behavior_reaction.cljs$core$IFn$_invoke$arity$variadic = call_behavior_reaction__delegate;
return call_behavior_reaction;
})()
;
lt.object.update_listeners = (function() {
var update_listeners = null;
var update_listeners__1 = (function (obj){return update_listeners.call(null,obj,null);
});
var update_listeners__2 = (function (obj,instants){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.set.call(null,cljs.core.concat.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(cur),lt.object.tags__GT_behaviors.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cur))));var trigs = lt.object.__GT_triggers.call(null,behs);var trigs__$1 = (cljs.core.truth_(new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs))?(function (){lt.object.raise_STAR_.call(null,obj,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs),null,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875));
return lt.object.__GT_triggers.call(null,behs);
})():trigs);var trigs__$2 = (cljs.core.truth_(instants)?trigs__$1:cljs.core.dissoc.call(null,trigs__$1,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875)));return cljs.core.assoc.call(null,cljs.core.deref.call(null,obj),new cljs.core.Keyword(null,"listeners","listeners",4090152369),trigs__$2);
});
update_listeners = function(obj,instants){
switch(arguments.length){
case 1:
return update_listeners__1.call(this,obj);
case 2:
return update_listeners__2.call(this,obj,instants);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
update_listeners.cljs$core$IFn$_invoke$arity$1 = update_listeners__1;
update_listeners.cljs$core$IFn$_invoke$arity$2 = update_listeners__2;
return update_listeners;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_object_STAR_ = (function() { 
var make_object_STAR___delegate = function (name,r){var obj = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"triggers","triggers",2516997421),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",4090152369),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666),name,new cljs.core.Keyword(null,"children","children",2673430897),cljs.core.PersistentArrayMap.EMPTY], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return obj;
};
var make_object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_object_STAR___delegate.call(this,name,r);};
make_object_STAR_.cljs$lang$maxFixedArity = 1;
make_object_STAR_.cljs$lang$applyTo = (function (arglist__5382){
var name = cljs.core.first(arglist__5382);
var r = cljs.core.rest(arglist__5382);
return make_object_STAR___delegate(name,r);
});
make_object_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_object_STAR___delegate;
return make_object_STAR_;
})()
;
lt.object.store_object_STAR_ = (function store_object_STAR_(obj){lt.object.add.call(null,obj);
return obj;
});
/**
* Return all objects for given type (template name)
*/
lt.object.instances_by_type = (function instances_by_type(type){return cljs.core.filter.call(null,(function (p1__5383_SHARP_){return cljs.core._EQ_.call(null,type,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__5383_SHARP_)));
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances)));
});
/**
* Merge map into object
*/
lt.object.merge_BANG_ = (function merge_BANG_(obj,m){if(cljs.core.truth_((function (){var and__3508__auto__ = m;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.map_QMARK_.call(null,m));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Merge requires a map: "),cljs.core.str(m)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,cljs.core.merge,m);
});
lt.object.handle_redef = (function handle_redef(odef){var id = new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(odef);var seq__5390_5396 = cljs.core.seq.call(null,lt.object.instances_by_type.call(null,id));var chunk__5392_5397 = null;var count__5393_5398 = 0;var i__5394_5399 = 0;while(true){
if((i__5394_5399 < count__5393_5398))
{var o_5400 = cljs.core._nth.call(null,chunk__5392_5397,i__5394_5399);var o_5401__$1 = cljs.core.deref.call(null,o_5400);var args_5402 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_5401__$1);var old_5403 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_5401__$1);var behs_5404 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_5401__$1));var inst_5405 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_5401__$1));var neue_5406 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_5405,args_5402):null);var neue_5407__$1 = ((cljs.core.vector_QMARK_.call(null,neue_5406))?crate.core.html.call(null,neue_5406):neue_5406);lt.object.merge_BANG_.call(null,inst_5405,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_5401__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_5404,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_5407__$1], null));
lt.object.merge_BANG_.call(null,inst_5405,lt.object.update_listeners.call(null,inst_5405));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_5403;if(cljs.core.truth_(and__3508__auto__))
{return neue_5407__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_5403,neue_5407__$1);
} else
{}
lt.object.raise.call(null,inst_5405,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__5408 = seq__5390_5396;
var G__5409 = chunk__5392_5397;
var G__5410 = count__5393_5398;
var G__5411 = (i__5394_5399 + 1);
seq__5390_5396 = G__5408;
chunk__5392_5397 = G__5409;
count__5393_5398 = G__5410;
i__5394_5399 = G__5411;
continue;
}
} else
{var temp__4092__auto___5412 = cljs.core.seq.call(null,seq__5390_5396);if(temp__4092__auto___5412)
{var seq__5390_5413__$1 = temp__4092__auto___5412;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5390_5413__$1))
{var c__4262__auto___5414 = cljs.core.chunk_first.call(null,seq__5390_5413__$1);{
var G__5415 = cljs.core.chunk_rest.call(null,seq__5390_5413__$1);
var G__5416 = c__4262__auto___5414;
var G__5417 = cljs.core.count.call(null,c__4262__auto___5414);
var G__5418 = 0;
seq__5390_5396 = G__5415;
chunk__5392_5397 = G__5416;
count__5393_5398 = G__5417;
i__5394_5399 = G__5418;
continue;
}
} else
{var o_5419 = cljs.core.first.call(null,seq__5390_5413__$1);var o_5420__$1 = cljs.core.deref.call(null,o_5419);var args_5421 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_5420__$1);var old_5422 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_5420__$1);var behs_5423 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_5420__$1));var inst_5424 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_5420__$1));var neue_5425 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_5424,args_5421):null);var neue_5426__$1 = ((cljs.core.vector_QMARK_.call(null,neue_5425))?crate.core.html.call(null,neue_5425):neue_5425);lt.object.merge_BANG_.call(null,inst_5424,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_5420__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_5423,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_5426__$1], null));
lt.object.merge_BANG_.call(null,inst_5424,lt.object.update_listeners.call(null,inst_5424));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_5422;if(cljs.core.truth_(and__3508__auto__))
{return neue_5426__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_5422,neue_5426__$1);
} else
{}
lt.object.raise.call(null,inst_5424,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__5427 = cljs.core.next.call(null,seq__5390_5413__$1);
var G__5428 = null;
var G__5429 = 0;
var G__5430 = 0;
seq__5390_5396 = G__5427;
chunk__5392_5397 = G__5428;
count__5393_5398 = G__5429;
i__5394_5399 = G__5430;
continue;
}
}
} else
{}
}
break;
}
return id;
});
/**
* Create object template (type) given keyword name and key-value pairs.
* These pairs serve as default attributes for an object. Following keys
* have special meaning:
* 
* * :behaviors - Set of object's behaviors
* * :tags - Set of object's tags
* * :triggers - Set of object's triggers
* * :init - Init fn called when object is created. Fn's return value
* is hiccup html content and saved to :content
* * :listeners (internal) - Map of triggers to vectors of behaviors
* @param {...*} var_args
*/
lt.object.object_STAR_ = (function() { 
var object_STAR___delegate = function (name,r){return lt.object.handle_redef.call(null,lt.object.store_object_STAR_.call(null,cljs.core.apply.call(null,lt.object.make_object_STAR_,name,r)));
};
var object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return object_STAR___delegate.call(this,name,r);};
object_STAR_.cljs$lang$maxFixedArity = 1;
object_STAR_.cljs$lang$applyTo = (function (arglist__5431){
var name = cljs.core.first(arglist__5431);
var r = cljs.core.rest(arglist__5431);
return object_STAR___delegate(name,r);
});
object_STAR_.cljs$core$IFn$_invoke$arity$variadic = object_STAR___delegate;
return object_STAR_;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_behavior_STAR_ = (function() { 
var make_behavior_STAR___delegate = function (name,r){var be = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"name","name",1017277949),name], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return be;
};
var make_behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_behavior_STAR___delegate.call(this,name,r);};
make_behavior_STAR_.cljs$lang$maxFixedArity = 1;
make_behavior_STAR_.cljs$lang$applyTo = (function (arglist__5432){
var name = cljs.core.first(arglist__5432);
var r = cljs.core.rest(arglist__5432);
return make_behavior_STAR___delegate(name,r);
});
make_behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_behavior_STAR___delegate;
return make_behavior_STAR_;
})()
;
lt.object.store_behavior_STAR_ = (function store_behavior_STAR_(beh){lt.object.add_behavior.call(null,beh);
return new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh);
});
lt.object.wrap_throttle = (function wrap_throttle(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"throttle","throttle",2497347228).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.throttle.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
lt.object.wrap_debounce = (function wrap_debounce(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"debounce","debounce",1556599227).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.debounce.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
/**
* @param {...*} var_args
*/
lt.object.behavior_STAR_ = (function() { 
var behavior_STAR___delegate = function (name,r){return lt.object.store_behavior_STAR_.call(null,lt.object.wrap_debounce.call(null,lt.object.wrap_throttle.call(null,cljs.core.apply.call(null,lt.object.make_behavior_STAR_,name,r))));
};
var behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return behavior_STAR___delegate.call(this,name,r);};
behavior_STAR_.cljs$lang$maxFixedArity = 1;
behavior_STAR_.cljs$lang$applyTo = (function (arglist__5433){
var name = cljs.core.first(arglist__5433);
var r = cljs.core.rest(arglist__5433);
return behavior_STAR___delegate(name,r);
});
behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = behavior_STAR___delegate;
return behavior_STAR_;
})()
;
/**
* Reduce over invoked object's behavior fns for given trigger. Start
* is initial value for reduce and any args are passed to behavior fn
* @param {...*} var_args
*/
lt.object.raise_reduce = (function() { 
var raise_reduce__delegate = function (obj,k,start,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return cljs.core.reduce.call(null,(function (res,cur){var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,cur));var args__$1 = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.concat.call(null,cljs.core.rest.call(null,cur),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.meta.call(null,cur):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.not.call(null,func))
{return res;
} else
{var _STAR_behavior_meta_STAR_5435 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
return cljs.core.apply.call(null,func,obj,res,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_5435;
}}
}),start,reactions);
};
var raise_reduce = function (obj,k,start,var_args){
var args = null;if (arguments.length > 3) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3),0);} 
return raise_reduce__delegate.call(this,obj,k,start,args);};
raise_reduce.cljs$lang$maxFixedArity = 3;
raise_reduce.cljs$lang$applyTo = (function (arglist__5436){
var obj = cljs.core.first(arglist__5436);
arglist__5436 = cljs.core.next(arglist__5436);
var k = cljs.core.first(arglist__5436);
arglist__5436 = cljs.core.next(arglist__5436);
var start = cljs.core.first(arglist__5436);
var args = cljs.core.rest(arglist__5436);
return raise_reduce__delegate(obj,k,start,args);
});
raise_reduce.cljs$core$IFn$_invoke$arity$variadic = raise_reduce__delegate;
return raise_reduce;
})()
;
/**
* Update object with update-in with [:key], fn and args
* @param {...*} var_args
*/
lt.object.update_BANG_ = (function() { 
var update_BANG___delegate = function (obj,r){return cljs.core.swap_BANG_.call(null,obj,(function (p1__5437_SHARP_){return cljs.core.apply.call(null,cljs.core.update_in,p1__5437_SHARP_,r);
}));
};
var update_BANG_ = function (obj,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return update_BANG___delegate.call(this,obj,r);};
update_BANG_.cljs$lang$maxFixedArity = 1;
update_BANG_.cljs$lang$applyTo = (function (arglist__5438){
var obj = cljs.core.first(arglist__5438);
var r = cljs.core.rest(arglist__5438);
return update_BANG___delegate(obj,r);
});
update_BANG_.cljs$core$IFn$_invoke$arity$variadic = update_BANG___delegate;
return update_BANG_;
})()
;
/**
* Update object with assoc-in for given key and value
*/
lt.object.assoc_in_BANG_ = (function assoc_in_BANG_(obj,k,v){if(cljs.core.truth_((function (){var and__3508__auto__ = k;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.sequential_QMARK_.call(null,k));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Associate requires a sequence of keys: "),cljs.core.str(k)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,(function (p1__5439_SHARP_){return cljs.core.assoc_in.call(null,p1__5439_SHARP_,k,v);
}));
});
lt.object.__GT_inst = (function __GT_inst(o){if(cljs.core.map_QMARK_.call(null,o))
{return cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o));
} else
{if(crate.binding.deref_QMARK_.call(null,o))
{return o;
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return cljs.core.deref.call(null,lt.object.instances).call(null,o);
} else
{return null;
}
}
}
});
/**
* Return DOM content associated with object
*/
lt.object.__GT_content = (function __GT_content(obj){return new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
});
/**
* Destroy object by calling its :destroy trigger, removing it from
* cache and removing associated DOM content
*/
lt.object.destroy_BANG_ = (function destroy_BANG_(obj){var temp__4092__auto__ = lt.object.__GT_inst.call(null,obj);if(cljs.core.truth_(temp__4092__auto__))
{var inst = temp__4092__auto__;lt.object.raise.call(null,inst,new cljs.core.Keyword(null,"destroy","destroy",2571277164));
cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.dissoc,lt.object.__GT_id.call(null,inst));
if(cljs.core.truth_(lt.object.__GT_content.call(null,obj)))
{lt.util.dom.remove.call(null,lt.object.__GT_content.call(null,obj));
} else
{}
return cljs.core.reset_BANG_.call(null,obj,null);
} else
{return null;
}
});
lt.object.store_inst = (function store_inst(inst){cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.assoc,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst)),inst);
return inst;
});
/**
* Create object given keyword name of object template or an object template
* and key-value pairs. See object* for special keys.
* During object creation the following happens to object in order:
* 
* * :init fn is called with given args
* * :object.instant trigger is raised
* * :init trigger is raised
* @param {...*} var_args
*/
lt.object.create = (function() { 
var create__delegate = function (obj_name,args){var obj = (((obj_name instanceof cljs.core.Keyword))?cljs.core.deref.call(null,lt.object.object_defs).call(null,obj_name):obj_name);var id = (function (){var or__3520__auto__ = new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.swap_BANG_.call(null,lt.object.obj_id,cljs.core.inc);
}
})();var inst = cljs.core.atom.call(null,cljs.core.assoc.call(null,cljs.core.dissoc.call(null,obj,new cljs.core.Keyword(null,"init","init",1017141378)),new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),id,new cljs.core.Keyword(null,"args","args",1016906831),args,new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(obj)),new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.set.call(null,cljs.core.conj.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(obj),new cljs.core.Keyword(null,"object","object",4285503153)))));var inst__$1 = lt.object.store_inst.call(null,inst);var _ = lt.object.merge_BANG_.call(null,inst__$1,lt.object.update_listeners.call(null,inst__$1));var content = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj),inst__$1,args):null);var content__$1 = ((cljs.core.vector_QMARK_.call(null,content))?crate.core.html.call(null,content):content);var final$ = lt.object.merge_BANG_.call(null,inst__$1,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"content","content",1965434859),content__$1], null));cljs.core.add_watch.call(null,inst__$1,new cljs.core.Keyword("lt.object","change","lt.object/change",2456955616),(function (___$1,___$2,___$3,___$4){return lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"object.change","object.change",966833329));
}));
lt.object.raise_STAR_.call(null,inst__$1,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst__$1))),null);
lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"init","init",1017141378));
return inst__$1;
};
var create = function (obj_name,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return create__delegate.call(this,obj_name,args);};
create.cljs$lang$maxFixedArity = 1;
create.cljs$lang$applyTo = (function (arglist__5440){
var obj_name = cljs.core.first(arglist__5440);
var args = cljs.core.rest(arglist__5440);
return create__delegate(obj_name,args);
});
create.cljs$core$IFn$_invoke$arity$variadic = create__delegate;
return create;
})()
;
lt.object.refresh_BANG_ = (function refresh_BANG_(obj){cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj))),null);
return lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.refresh","object.refresh",4196174494));
});
/**
* Add behavior to object and update its listeners
*/
lt.object.add_behavior_BANG_ = (function add_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),cljs.core.conj,behavior);
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
/**
* Remove behavior from object and update its listeners
*/
lt.object.rem_behavior_BANG_ = (function rem_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),(function (p1__5441_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),p1__5441_SHARP_);
}));
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
lt.object.__GT_def = (function __GT_def(def_BAR_name){if(cljs.core.map_QMARK_.call(null,def_BAR_name))
{return def_BAR_name;
} else
{return cljs.core.deref.call(null,lt.object.object_defs).call(null,def_BAR_name);
}
});
/**
* Find object by its unique numerical id
*/
lt.object.by_id = (function by_id(id){if(cljs.core.truth_(id))
{return cljs.core.deref.call(null,lt.object.instances).call(null,id);
} else
{return null;
}
});
/**
* Find objects that have given tag
*/
lt.object.by_tag = (function by_tag(tag){return cljs.core.sort_by.call(null,cljs.core.comp.call(null,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),cljs.core.deref),cljs.core.filter.call(null,(function (p1__5442_SHARP_){var temp__4092__auto__ = new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__5442_SHARP_));if(cljs.core.truth_(temp__4092__auto__))
{var ts = temp__4092__auto__;return ts.call(null,tag);
} else
{return null;
}
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances))));
});
lt.object.in_tag_QMARK_ = (function in_tag_QMARK_(tag,behavior){return cljs.core.first.call(null,cljs.core.filter.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),cljs.core.deref.call(null,lt.object.tags).call(null,tag)));
});
/**
* Return truthy if object has tag
*/
lt.object.has_tag_QMARK_ = (function has_tag_QMARK_(obj,tag){return new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)).call(null,tag);
});
/**
* Add tags to given object and updates effected behaviors and listeners.
* ::tags-added trigger is raised on object after update
*/
lt.object.add_tags = (function add_tags(obj,ts){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),(function (p1__5443_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,p1__5443_SHARP_,cljs.core.filter.call(null,cljs.core.identity,ts));
}));
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),ts);
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),ts),null);
return obj;
});
/**
* Remove tags from given object and updates effected behaviors and listeners.
* ::tags-removed trigger is raised on object after update
*/
lt.object.remove_tags = (function remove_tags(obj,ts){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),ts));var cur__$1 = cljs.core.update_in.call(null,cljs.core.update_in.call(null,cljs.core.update_in.call(null,cur,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),((function (cur,behs){
return (function (p1__5444_SHARP_){return cljs.core.reduce.call(null,cljs.core.disj,p1__5444_SHARP_,ts);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),((function (cur,behs){
return (function (p1__5445_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behs], true),p1__5445_SHARP_);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",4090152369)], null),((function (cur,behs){
return (function (p1__5446_SHARP_){return cljs.core.apply.call(null,cljs.core.dissoc,p1__5446_SHARP_,ts);
});})(cur,behs))
);lt.object.merge_BANG_.call(null,obj,cur__$1);
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),ts);
return obj;
});
/**
* Associate behaviors to given tag and refresh objects with given tag
*/
lt.object.tag_behaviors = (function tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__5447_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,(function (){var or__3520__auto__ = p1__5447_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})(),behs);
}));
var seq__5452_5456 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__5453_5457 = null;var count__5454_5458 = 0;var i__5455_5459 = 0;while(true){
if((i__5455_5459 < count__5454_5458))
{var cur_5460 = cljs.core._nth.call(null,chunk__5453_5457,i__5455_5459);lt.object.refresh_BANG_.call(null,cur_5460);
{
var G__5461 = seq__5452_5456;
var G__5462 = chunk__5453_5457;
var G__5463 = count__5454_5458;
var G__5464 = (i__5455_5459 + 1);
seq__5452_5456 = G__5461;
chunk__5453_5457 = G__5462;
count__5454_5458 = G__5463;
i__5455_5459 = G__5464;
continue;
}
} else
{var temp__4092__auto___5465 = cljs.core.seq.call(null,seq__5452_5456);if(temp__4092__auto___5465)
{var seq__5452_5466__$1 = temp__4092__auto___5465;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5452_5466__$1))
{var c__4262__auto___5467 = cljs.core.chunk_first.call(null,seq__5452_5466__$1);{
var G__5468 = cljs.core.chunk_rest.call(null,seq__5452_5466__$1);
var G__5469 = c__4262__auto___5467;
var G__5470 = cljs.core.count.call(null,c__4262__auto___5467);
var G__5471 = 0;
seq__5452_5456 = G__5468;
chunk__5453_5457 = G__5469;
count__5454_5458 = G__5470;
i__5455_5459 = G__5471;
continue;
}
} else
{var cur_5472 = cljs.core.first.call(null,seq__5452_5466__$1);lt.object.refresh_BANG_.call(null,cur_5472);
{
var G__5473 = cljs.core.next.call(null,seq__5452_5466__$1);
var G__5474 = null;
var G__5475 = 0;
var G__5476 = 0;
seq__5452_5456 = G__5473;
chunk__5453_5457 = G__5474;
count__5454_5458 = G__5475;
i__5455_5459 = G__5476;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.deref.call(null,lt.object.tags).call(null,tag);
});
lt.object.remove_tag_behaviors = (function remove_tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__5477_SHARP_){return cljs.core.remove.call(null,cljs.core.set.call(null,behs),(function (){var or__3520__auto__ = p1__5477_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})());
}));
var seq__5490 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__5495 = null;var count__5496 = 0;var i__5497 = 0;while(true){
if((i__5497 < count__5496))
{var cur = cljs.core._nth.call(null,chunk__5495,i__5497);var seq__5498_5502 = cljs.core.seq.call(null,behs);var chunk__5499_5503 = null;var count__5500_5504 = 0;var i__5501_5505 = 0;while(true){
if((i__5501_5505 < count__5500_5504))
{var b_5506 = cljs.core._nth.call(null,chunk__5499_5503,i__5501_5505);lt.object.rem_behavior_BANG_.call(null,cur,b_5506);
{
var G__5507 = seq__5498_5502;
var G__5508 = chunk__5499_5503;
var G__5509 = count__5500_5504;
var G__5510 = (i__5501_5505 + 1);
seq__5498_5502 = G__5507;
chunk__5499_5503 = G__5508;
count__5500_5504 = G__5509;
i__5501_5505 = G__5510;
continue;
}
} else
{var temp__4092__auto___5511 = cljs.core.seq.call(null,seq__5498_5502);if(temp__4092__auto___5511)
{var seq__5498_5512__$1 = temp__4092__auto___5511;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5498_5512__$1))
{var c__4262__auto___5513 = cljs.core.chunk_first.call(null,seq__5498_5512__$1);{
var G__5514 = cljs.core.chunk_rest.call(null,seq__5498_5512__$1);
var G__5515 = c__4262__auto___5513;
var G__5516 = cljs.core.count.call(null,c__4262__auto___5513);
var G__5517 = 0;
seq__5498_5502 = G__5514;
chunk__5499_5503 = G__5515;
count__5500_5504 = G__5516;
i__5501_5505 = G__5517;
continue;
}
} else
{var b_5518 = cljs.core.first.call(null,seq__5498_5512__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_5518);
{
var G__5519 = cljs.core.next.call(null,seq__5498_5512__$1);
var G__5520 = null;
var G__5521 = 0;
var G__5522 = 0;
seq__5498_5502 = G__5519;
chunk__5499_5503 = G__5520;
count__5500_5504 = G__5521;
i__5501_5505 = G__5522;
continue;
}
}
} else
{}
}
break;
}
{
var G__5523 = seq__5490;
var G__5524 = chunk__5495;
var G__5525 = count__5496;
var G__5526 = (i__5497 + 1);
seq__5490 = G__5523;
chunk__5495 = G__5524;
count__5496 = G__5525;
i__5497 = G__5526;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__5490);if(temp__4092__auto__)
{var seq__5490__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5490__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__5490__$1);{
var G__5527 = cljs.core.chunk_rest.call(null,seq__5490__$1);
var G__5528 = c__4262__auto__;
var G__5529 = cljs.core.count.call(null,c__4262__auto__);
var G__5530 = 0;
seq__5490 = G__5527;
chunk__5495 = G__5528;
count__5496 = G__5529;
i__5497 = G__5530;
continue;
}
} else
{var cur = cljs.core.first.call(null,seq__5490__$1);var seq__5491_5531 = cljs.core.seq.call(null,behs);var chunk__5492_5532 = null;var count__5493_5533 = 0;var i__5494_5534 = 0;while(true){
if((i__5494_5534 < count__5493_5533))
{var b_5535 = cljs.core._nth.call(null,chunk__5492_5532,i__5494_5534);lt.object.rem_behavior_BANG_.call(null,cur,b_5535);
{
var G__5536 = seq__5491_5531;
var G__5537 = chunk__5492_5532;
var G__5538 = count__5493_5533;
var G__5539 = (i__5494_5534 + 1);
seq__5491_5531 = G__5536;
chunk__5492_5532 = G__5537;
count__5493_5533 = G__5538;
i__5494_5534 = G__5539;
continue;
}
} else
{var temp__4092__auto___5540__$1 = cljs.core.seq.call(null,seq__5491_5531);if(temp__4092__auto___5540__$1)
{var seq__5491_5541__$1 = temp__4092__auto___5540__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5491_5541__$1))
{var c__4262__auto___5542 = cljs.core.chunk_first.call(null,seq__5491_5541__$1);{
var G__5543 = cljs.core.chunk_rest.call(null,seq__5491_5541__$1);
var G__5544 = c__4262__auto___5542;
var G__5545 = cljs.core.count.call(null,c__4262__auto___5542);
var G__5546 = 0;
seq__5491_5531 = G__5543;
chunk__5492_5532 = G__5544;
count__5493_5533 = G__5545;
i__5494_5534 = G__5546;
continue;
}
} else
{var b_5547 = cljs.core.first.call(null,seq__5491_5541__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_5547);
{
var G__5548 = cljs.core.next.call(null,seq__5491_5541__$1);
var G__5549 = null;
var G__5550 = 0;
var G__5551 = 0;
seq__5491_5531 = G__5548;
chunk__5492_5532 = G__5549;
count__5493_5533 = G__5550;
i__5494_5534 = G__5551;
continue;
}
}
} else
{}
}
break;
}
{
var G__5552 = cljs.core.next.call(null,seq__5490__$1);
var G__5553 = null;
var G__5554 = 0;
var G__5555 = 0;
seq__5490 = G__5552;
chunk__5495 = G__5553;
count__5496 = G__5554;
i__5497 = G__5555;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.object.__BEH__add_tag = (function __BEH__add_tag(this$,t){if(cljs.core.truth_(t))
{return lt.object.add_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","add-tag","lt.object/add-tag",1703923742),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__add_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Add tag to object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__remove_tag = (function __BEH__remove_tag(this$,t){if(cljs.core.truth_(lt.object.has_tag_QMARK_.call(null,this$,t)))
{return lt.object.remove_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","remove-tag","lt.object/remove-tag",3883925951),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__remove_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Remove tag from object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__shadow_tag = (function __BEH__shadow_tag(this$,to_shadow,to_add){var has_shadow_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_shadow);var has_add_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_add);if(cljs.core.truth_((function (){var and__3508__auto__ = has_shadow_QMARK_;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not.call(null,has_add_QMARK_);
} else
{return and__3508__auto__;
}
})()))
{return lt.object.add_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(cljs.core.truth_((function (){var and__3508__auto__ = cljs.core.not.call(null,has_shadow_QMARK_);if(and__3508__auto__)
{return has_add_QMARK_;
} else
{return and__3508__auto__;
}
})()))
{return lt.object.remove_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return null;
} else
{return null;
}
}
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","shadow-tag","lt.object/shadow-tag",1731213395),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__shadow_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Shadow a tag on an object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to shadow"], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to add"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__report_time = (function __BEH__report_time(this$,beh,time,trigger){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.log([cljs.core.str(beh),cljs.core.str(" triggered by "),cljs.core.str(trigger),cljs.core.str(" took "),cljs.core.str(time),cljs.core.str("ms")].join(''));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","report-time","lt.object/report-time",1387009782),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__report_time,new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),null], null), null));
